// Package cothority is a set of applications, services and protocols that
// serve a collective authority. A cothority is composed of a set of servers,
// called conodes. Conodes collectively execute decentralized protocols, e.g.,
// for collective signing, threshold signing, Byzantine agreement, or
// generation of public-randomness. The software in this repository allows you
// to access the services of a cothority through different client applications
// and/or run your own cothority server.
//
// In this repository you find applications to interact with your cothority,
// services that offer an API to the cothority from the outside world, and
// protocols who make conodes work together.
//
// For further documentation, please go to
// https://github.com/dedis/cothority/blob/master/README.md.
//
// Some examples of what you can do with a cothority:
// (1) https://pulsar.dedis.ch,
// (2) http://status.dedis.ch and
// (3) https://pop.dedis.ch.
//
// If you have questions or remarks on the cothority project, feel free to
// reach out to us through our mailing list at
// https://groups.google.com/forum/#!forum/cothority or by email to
// dedis@epfl.ch.
package cothority
